<?

/*

Nanoweb CGI support module
==========================

Copyright (C) 2002-2003 Vincent Negrier aka. sIX <six@aegis-corp.org>

This program is free software; you can redistribute it and/or modify
it under the terms of the GNU General Public License as published by
the Free Software Foundation; either version 2, or (at your option)
any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA 02111-1307, USA.

*/

class mod_cgi {

	// Constructor
	
	function mod_cgi() {

		$this->modtype="parser_CGI";
		$this->modname="CGI support";

	}

	// Init

	function init() {

		// Register also as a core hook module
		
		$GLOBALS["modules"]["core_after_decode"][]=&$this;

	}

	// After decode hook

	function main() {

		global $accessdir, $docroot, $http_uri, $pri_parser, $pri_err, $add_errmsg;

		if (is_file($docroot.$http_uri)) {
		
			if ($cgiscd=access_query("cgiscriptsdir")) foreach ($cgiscd as $cgidir) if (strpos(rtrim($accessdir, "/"), rtrim($cgidir, "/"))===0) {

				if (is_callable("is_executable")) {
				
					$isexec=is_executable($docroot.$http_uri);

				} else $isexec=true;

				if ($isexec) {
				
					$pri_parser='CGI $SCRIPT_FILENAME';

				} else {

					switch (access_query("cgiscriptnoexec", 0)) {

						case "error":

						$pri_err=500;
						$add_errmsg="mod_cgi: the file is not executable<br><br>";

						break;


						case "raw":
						default:
						
					}
					
				}

				break;

			}
	
		}
	
	}
	
	// Parser functions	
	
	function parser_open($args, $filename, &$rq_err, &$cgi_headers, &$add_ctype) {

		global $conf, $os;

		$cgiexec=$args;

		if ($phpopts=access_query("cgiphpoption")) foreach ($phpopts as $opt) $cgiexec.=" -d ".$opt;

		$nsv=nw_server_vars();
		if ($conf["global"]["cgifilterpathinfo"][0]) unset($nsv["PATH_INFO"]);

		// Workaround for the PHP putenv("VAR=") bug on win32, remove when PHP is fixed
		
		switch ($os) {

			case "unix": 
			foreach($nsv as $key=>$var) putenv($key."=".$var);
			break;

			case "win32":
			foreach($nsv as $key=>$var) putenv($key.($var?("=".$var):""));
			break;
			
		
		}

		foreach($nsv as $key=>$var) putenv($key."=".$var);
		
		putenv("GATEWAY_INTERFACE=CGI/1.1");

		if ($rq_hdrs=$GLOBALS["htreq_headers"]) foreach($rq_hdrs as $key=>$val) putenv("HTTP_".str_replace("-", "_", $key)."=".$val);
		
		if ($rq_hdrs["CONTENT-LENGTH"]) {
		
			putenv("CONTENT_TYPE=".$rq_hdrs["CONTENT-TYPE"]);
			putenv("CONTENT_LENGTH=".$rq_hdrs["CONTENT-LENGTH"]);

			$tmp_filename=$conf["global"]["tempdirectory"][0].DIRECTORY_SEPARATOR."nweb_cgi_post.".$GLOBALS["mypid"];

			$ftmp=fopen($tmp_filename, "w");
			if ($os=="unix") chmod($tmp_filename, 0600);
			fwrite($ftmp, $GLOBALS["htreq_content"]);
			fclose($ftmp);
			$this->tmpfile=$tmp_filename;

			switch ($os) {
				case "unix": $cgipiped=$cgiexec."<".$tmp_filename; break;
				case "win32": $cgipiped="TYPE ".$tmp_filename."|".$cgiexec; break;
			}
			
			if (!$this->p=@popen($cgipiped, NW_BSAFE_READ_OPEN)) {

				$this->peof=true;
				$rq_err=500;
				techo("WARN: cannot open pipe to '".$cgiexec."'", NW_EL_WARNING);

			} else $this->peof=false;
		
		} else {

			if (!$this->p=@popen($cgiexec, NW_BSAFE_READ_OPEN)) {
				
				$this->peof=true;
				$rq_err=500;
				techo("WARN: cannot open pipe to '".$cgiexec."'", NW_EL_WARNING);

			} else $this->peof=false;

		}

		if ($this->p) while ($lastread!="\r\n" && $lastread!="\n") {
			
			if (!$lastread=fgets($this->p, 1024)) break;
			$content.=$lastread;
		}

		if ( (($p1=strpos($content, "\r\n\r\n"))!==false) || (($p1=strpos($content, "\n\n"))!==false) ) {
		
			if ((strpos($content, "\r\n\r\n"))!==false) $pn=4; else $pn=2;
			$headers=explode("\n", trim(substr($content, 0, $p1)));
			$content=substr($content, $p1+$pn);

		}

		$GLOBALS["http_resp"]="";
		
		$hcount=count($headers)-1;

		for($a=0;$a<=$hcount;$a++) if ($s=trim($headers[$a])) {

			if (substr($s, 0, 5)=="HTTP/") {

				$hd_key="";
				$tmp=explode(" ", $s);
				$rq_err=(int)$tmp[1];
			
			} else {
			
				$hd_key=substr($s, 0, strpos($s, ":"));
				$hd_val=trim(substr($s,strpos($s, ":")+1));

			}

			if ($hd_key) {
			
				if (strtoupper($hd_key)=="SET-COOKIE") {
					
					$cgi_headers["cookies"][]=$hd_val;

				} else {

					$cgi_headers[$hd_key]=$hd_val;

				}

			}
		
		}

	}

	function parser_get_output() {

		$tmp=fread($this->p, 1024);
		if (feof($this->p)) $this->peof=true;
		return($tmp);
	
	}
	
	function parser_eof() {

		return($this->peof);
	
	}
	
	function parser_close() {

		if ($this->tmpfile && is_file($this->tmpfile)) unlink($this->tmpfile);
		@pclose($this->p);

	}

}

?>
