<?php

# Uses a template html page for all server generated messages (directory
# listings and error responses)
#
# ThemeTemplate = /path/to/nwtemplate.html
#  
#  - the template should contain a <CONTENT>, <MESSAGE>
#    or at least _one_ empty line, where the server message
#    should be placed into
#  - should also contain <title>@TITLE</title>
#  - @CONTENT@ is the htmlentitied(server message)
#  - upper case is important!


class theme_template {

	var $modtype = "theme_template";
	var $modname = "theme: template for server messages";

	function page($title, $body, $head="") {

		global $docroot;

		if ((file_exists($tfn=access_query("themetemplate", 0)) ||file_exists($tfn=$docroot.DIRECTORY_SEPARATOR.$tfn)) && is_readable($tfn) && ($template = @implode("", @file($tfn)))) {


			$tlen0 = strlen($template);
			foreach (array("<CONTENT>", "<MESSAGE>") as $content_tag) {

				$template = str_replace($content_tag, $body, $template);

			}
			$template = str_replace("@CONTENT@", htmlentities($body), $template);
			if ($tlen0 == strlen($template)) {
				techo("theme_template: could not insert message content into template", NW_EL_WARN);
			}

			if (strpos($template, "@TITLE@")) {
				$template = str_replace("@TITLE@", $title, $template);
			}
			elseif ($p=strpos($template, "</title>")) {
				$template = substr($template, 0, $p) . $title . substr($template, $p);
			}
			else {
				techo("theme_template: no @TITLE@ in the template", NW_EL_WARN);
			}

			if ($p=strpos($template, "</head>")) {
				$template = substr($template, 0, $p) . $head . substr($template, $p);
			}

			return($template);

		}
		else {

			techo("theme_template: file '$tfn' not found or not readable", NW_EL_WARN);
			return(false);

		}

	}

}

?>